Name: libc
Summary: standard shared libraries for programs
Version: 5.4.46
Release: fr2
ExclusiveArch: i386 sparc m68k
ExclusiveOS: Linux
Copyright: GPL
Group: Libraries
Source: ftp://sunsite.unc.edu:/pub/Linux/GCC/libc-%{PACKAGE_VERSION}.tar.gz
Patch0: libc-5.4.46-config.patch
Patch1: libc-5.4.46-wchar.patch
Patch2: libc-5.4.46-realpath.patch
Patch3: libc-5.4.46-crosscompile.patch
Patch4: libc-5.3.12-2.0kern.patch
Patch5: redhat.diff
Patch6: libc-5.3.12-readdir.patch
Patch7: libc-5.3.12-lckpwdf.patch
Patch8: libc-5.3.12-sparc-config-malloc.patch
Patch9: libc-5.3.12-sparc-siglist.patch
Patch10: libc-5.3.12-reentrant.patch
Patch11: libc-5.3.12-miscsecure.patch
Patch12: libc-5.3.12-nys.patch
Patch13: libc-5.3.12-sigaction.patch
Patch14: libc-5.3.12-sparc-threaded-errno.patch
Patch15: libc-5.3.12-headers.patch
BuildRoot: /tmp/libc-build/
Conflicts: fatrat-release >= 0.1
Distribution: fatrat

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries/Libc
Requires: kernel-headers binutils
%package static
Summary: Libraries for static linking
Group: Development/Libraries/Libc
Requires: binutils
%package profile
Summary: libc with profiling support
Group: Development/Libraries/Libc
Requires: binutils
%package debug
Summary: libc with debugging information
Group: Development/Libraries/Libc
Requires: binutils

%changelog

* Mon Feb 28 2000 meurer@gmx.de

- compile on mac68k

* Mon Dec 27 1999 Frank Meurer <meurer@gmx.de>

- update patches for version 5.4.46
- set input of ./configure to configuration for cross-compilation
- skip wchar-patch, it didn't compile
- change "tar cvSpf - include ..." to "tar cSpf - include ..."

* Sun Oct 25 1998 Jochen Stein <jst@writeme.com>

- Security fix from Olaf Kirch included

* Sun Jun 28 1998 Jochen Stein <jst@writeme.com>

- Version 5.4.46
- now requires ld.so 1.9.9

* Sat Feb 21 1998 Jochen Stein <jst@writeme.com>

- Version 5.4.44
- Fixed some clashes with other packages

* Thu Sep 25 1997 Jun NISHII <nishii@postman.riken.go.jp>

- Added /lib/{libc,libm}.so.5 in files field

* Thu Sep 22 1997 Daisuke SUZUKI <daisuke@linux.or.jp>

- Changed for gcc-2.7.2.2 or newer.

* Thu Sep 18 1997 Toshio Kuratomi <badger@prtr-13.ucsc.edu>

- Minimal change!! Added a requirement for ld.so >= 1.9.5.

* Tue Sep 16 1997 Toshio Kuratomi <badger@prtr-13.ucsc.edu>

- Version 5.4.38

* Sat May 31 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.33
- Changed BuildRoot to use /tmp instead of /var/tmp
- Binaries of locale & localedef are now stripped.
- Removed 'make depend'
- Removed RPM_OPT_FLAGS

* Tue May 27 1997 Toshio Kuratomi <badger@prtr-13.ucsc.edu>

- Added ${RPM_OPT_FLAGS} to the make CFLAGS
- Patched locale/Makefile to get it to link the new library in.
- Changed libc-5.4.28-config.patch to properly use BuildRoot

* Sun May 25 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.31

* Mon May 19 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.30
- Some minor changes to spec-file

* Mon May 12 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.28
- Added locale-patch from libc-5.4.26-package I found from contrib.

* Tue Apr 08 1997 Erik Troan <ewt@redhat.com>

(this entry is taken from Red Hat 4.2 libc-5.3.12 src package)
- Fixed _P in sched.h
- Removed /usr/include/linux /usr/include/asm symlinks which have been moved
  to the kernel package

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to 
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a 
Linux system will not function.

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and object
files available for creating the executables.

%description static
While most programs are distributed dynamically linked, and therefore need
access to the standard shared libraries, some developers prefer to
ship programs statically linked, which includes all of the standard library
code in the executable. While this results in significantly larger 
programs and increases their memory usage, it does increase the portability
of programs between Linux systems.

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%description debug
These libraries have the debugging information debuggers use for tracing
the execution of programs. These are only needed when the shared libraries
themselves are being debugged -- they are not needed to debug programs which
use them. 

%package -n locale
Summary: Tools for manipulation locale definition files for other languages
Group: Utilities/Text
%description -n locale
This package includes the tools necessary to generate and manipulate the
locale definition files that libc uses to provide multi-lingual support.

%prep
%setup -c

%patch0 -p1
#%patch1 -p1 -b .wchar
%patch2 -p1 -b .realpath
#%patch3 -p1 -b .crosscompile
#%patch2 -p1 -b .links
#%patch3 -p1 -b .library

#%patch12 -p1 -b .headers
#find . -name "*.headers" | xargs rm

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

mkdir $RPM_BUILD_ROOT/etc
mkdir $RPM_BUILD_ROOT/usr
mkdir $RPM_BUILD_ROOT/usr/include

cd include
# Assumes that the kernel sources are in their standard places...
ln -s /usr/src/linux/include/linux .
ln -s /usr/src/linux/include/asm .

cd ../libc
mv config.in config.in.tmpl
sed "s&REPLACEMEWITHTARGET&$RPM_BUILD_ROOT&" < config.in.tmpl > config.in

%build

cd libc

./configure <<EOF

EOF
%ifarch m68k
  read
  #PROFILE_OPT_CFLAGS=-O -pg -D__GPROF__ # -mreg-alloc=d
  #PIC_OPT_CFLAGS="-fPIC -O6 -funroll-loops -fomit-frame-pointer -g1 -m68030 -m68881"
  # *** gcc-2.7.2.3,can't use any -O? opts, libpthreads/sig.c:
  #sig.c:70: parse error before `*'
  #sig.c:71: parse error before `*'
  make \
    OPT_CFLAGS="-m68030 -m68881 -fomit-frame-pointer -O6" \
    PIC_OPT_CFLAGS="-fPIC -O6 -funroll-loops -fomit-frame-pointer -g1 -m68030 -m68881" \
    GCOPTS="-O6 -Wall -m68030 -m68881 -fomit-frame-pointer" \
    PROFILE_OPT_CFLAGS="-O6 -m68030 -m68881 -fomit-frame-pointer" \
    DEBUG_OPT_CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer -g" \
    CHECKER_OPT_CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer" \
    
  make \
    OPT_CFLAGS="-m68030 -m68881 -fomit-frame-pointer -O6" \
    PIC_OPT_CFLAGS="-fPIC -O6 -funroll-loops -fomit-frame-pointer -g1 -m68030 -m68881" \
    GCOPTS="-O6 -Wall -m68030 -m68881 -fomit-frame-pointer" \
    PROFILE_OPT_CFLAGS="-O6 -m68030 -m68881 -fomit-frame-pointer" \
    DEBUG_OPT_CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer -g" \
    CHECKER_OPT_CFLAGS="-O2 -m68030 -m68881 -fomit-frame-pointer" \
    -C locale programs
%else
  make
  #make -C locale localedef
  make -C locale programs
%endif

%install
rm -rf $RPM_BUILD_ROOT
# Needed for the locale progs...
mkdir -p $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/etc $RPM_BUILD_ROOT/lib $RPM_BUILD_ROOT/usr/lib $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include

tar cvSpf - include | (cd $RPM_BUILD_ROOT/usr; tar xSpf -)

# this comes from the linuxthreads package
rm -f $RPM_BUILD_ROOT/usr/include/pthread.h

install -m755 -s libc/locale/locale $RPM_BUILD_ROOT/usr/bin/locale
install -m755 -s libc/locale/localedef $RPM_BUILD_ROOT/usr/bin/localedef

cd libc
make RPM_BUILD_ROOT="$RPM_BUILD_ROOT" install

rm -f $RPM_BUILD_ROOT/usr/include/linux $RPM_BUILD_ROOT/usr/include/asm
ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -sf ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm

install -m644 nys/nsw/etc/nsswitch.conf $RPM_BUILD_ROOT/etc

cd $RPM_BUILD_ROOT/lib
rm -f libc.so libm.so libc.so.5 libm.so.5
ln -sf ../../lib/libc.so.%{PACKAGE_VERSION} libc.so.5
ln -sf ../../lib/libm.so.5.0.9 libm.so.5
ln -sf ../../lib/libc.so.%{PACKAGE_VERSION} libc.so
ln -sf ../../lib/libm.so.5.0.9 libm.so
cd $RPM_BUILD_ROOT/usr/lib
rm -f libc.so libm.so
ln -sf ../../lib/libc.so.%{PACKAGE_VERSION} libc.so
ln -sf ../../lib/libm.so.5.0.9 libm.so
rm -f $RPM_BUILD_ROOT/usr/include/ansidecl.h
rm -f $RPM_BUILD_ROOT/usr/include/obstack.h
rm -f $RPM_BUILD_ROOT/usr/include/linux
rm -f $RPM_BUILD_ROOT/usr/include/asm

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%doc libc/README.nys libc/nys/README libc/nys/nis/etc/nis.conf libc/nys/yp/etc/yp.conf
%config /etc/nsswitch.conf
/lib/libc.so.%{PACKAGE_VERSION}
/lib/libm.so.5.0.9
/lib/libc.so.5
/lib/libm.so.5
/lib/libc.so
/lib/libm.so

%files devel
/usr/lib/crt1.o
/usr/lib/crtbegin.o
/usr/lib/crtbeginS.o
/usr/lib/crtend.o
/usr/lib/crtendS.o
/usr/lib/crti.o
/usr/lib/crtn.o
/usr/lib/gcrt1.o
/usr/lib/libbsd.a
/usr/lib/libgmon.a
/usr/lib/libmcheck.a
/usr/lib/libc.so
/usr/lib/libm.so
/usr/include/


%files static
/usr/lib/libc.a
/usr/lib/libm.a

%files profile
/usr/lib/libc_p.a

%files debug
/usr/lib/libg.a

%files -n locale
/usr/bin/locale
/usr/bin/localedef
